import java.io.*;
import java.net.*;

/**
 * Simple client that goes to a URL, downloads it, and prints it to a file.
 * The first argument is the URL, the second (optional) arg is the output file.
 **/

public class HttpClient {
  public static void main(String[] args) {
    
    //Check # of args
    if((args.length!=1)&&(args.length!=2)) 
       throw new IllegalArgumentException("Wrong number of arguments");
       
    //Open file for output
    try{ 
      OutputStream outfile;
      if(args.length==2) 
	outfile=new FileOutputStream(args[1]);
      else
	outfile=System.out;
      

      //Open URL and dump contents.  
      try {
	URL url=new URL(args[0]);
	String protocol=url.getProtocol();
	if(!protocol.equals("http"))
	  throw new IllegalArgumentException("Must provide URL");
	String host=url.getHost();
	System.out.println(host);
	int port=url.getPort();
	if(port==-1) port=80;
	String filename=url.getFile();
	System.out.println(filename);
	Socket socket=new Socket(host,port);
	InputStream from_server=socket.getInputStream();
	PrintWriter to_server
	  =new PrintWriter(new OutputStreamWriter(socket.getOutputStream()));
	to_server.println("GET"+filename);
	to_server.flush();
	
	byte[] buffer=new byte[4096];
	int bytes_read;
	while((bytes_read=from_server.read(buffer))!=-1)
	  outfile.write(buffer,0,bytes_read);
	socket.close();
	outfile.close();
      }
      catch(Exception e) {
	System.out.println(e);
      }
    }
    catch(IOException e) {;}
  }
}
